require 'java'
java_import 'SimpleSSLSocket'

module MTLumberjack
  #
  #  This class provides a wrapper for Java's SSL Socket. This wrapper is needed when running Logstash 
  # on IBM's Java to ship logs to Logmet.
  #
  class SSLSocket
    def initialize(endpoint, port)
      @socket = SimpleSSLSocket.new(endpoint, port)
    end
    
    def connect()
      @socket.connect()
    end
    
    def syswrite(byte_array)
      @socket.syswrite(byte_array.to_java_bytes)
    end
    
    def sysread(n_bytes)
      bytes = @socket.sysread(n_bytes)
      return bytes.to_s
    end
    
    def close()
      @socket.sysclose()
    end
    
    def sysclose()
      @socket.sysclose()
    end
    
    def flush()
      @socket.flush()
    end
    
    def set_read_timeout(timeout)
      @socket.set_read_timeout(timeout)
    end
    
    def setsockopts(ignored, ignored2, ignored3)
    end
  end
end